;   boot.asm: Load CP/M from ROM

;   Calc CPM addresses
msize       equ     32                  ; 32k RAM
sectors     equ     16                  ; sectors per track for my system
systrks     equ     4                   ; my boot system has 4 tracks =-int(-52/16) 
bias        equ     (msize-20-1)*1024   ; adjusted for my system =int((52+4-4*16)/8)
ccp         equ     3400h+bias
cstart      equ     4a00h+bias

    org     8000h                       ; executed in ROM after shift down
    jmp     8003h                       ; reset bootstrap
boot:
    di                                  ; disable interrupts
    mvi     a,0dfh                      ; set SOD high and turn off RSTX.X
    sim               
    lxi     sp,ccp-0080h                ; convenient place
    lxi     d,ccp-0080h                 ; start of boot dst
    lxi     h,8000h                     ; start of ROM (boot src)
    mvi     c,sectors                   ; sectors per track
    mvi     b,systrks                   ; sytem track count
    push    b                           ; save <bc>
boot$nextsect:
    mvi     b,128                       ; sector size
boot$copysect:
    mov     a,m
    inx     h
    stax    d
    inx     d
    dcr     b
    jnz     boot$copysect
    dcr     c
    jnz     boot$nextsect
    pop     b
    dcr     b
    push    b
    jnz     boot$nextsect
;   Cold boot
    jmp     cstart
    end
